---
title: offset-path
slug: Web/CSS/offset-path
tags:
  - CSS
  - CSS Motion Path
  - Experimental
  - Motion Path
  - Reference
  - motion-path
  - offset-path
  - 'recipe:css-property'
---
<div>{{cssref}}</div>

<p>The <strong><code>offset-path</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property specifies a motion path for an element to follow and defines the element's positioning within the parent container or SVG coordinate system.</p>

<div>{{EmbedInteractiveExample("pages/css/offset-path.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css notranslate">/* Default */
offset-path: none;

/* Function values */
offset-path: ray(45deg closest-side contain);

/* URL */
offset-path: url(#path);

/* Shapes */
offset-path: circle(50% at 25% 25%);
offset-path: inset(50% 50% 50% 50%);
offset-path: polygon(30% 0%, 70% 0%, 100% 50%, 30% 100%, 0% 70%, 0% 30%);
offset-path: path('M 0,200 Q 200,200 260,80 Q 290,20 400,0 Q 300,100 400,200');

/* Geometry Boxes */
offset-path: margin-box;
offset-path: stroke-box;

/* Global values */
offset-path: inherit;
offset-path: initial;
offset-path: unset;
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>ray()</code></dt>
 <dd>Taking up to three values, defines a path that is a line segment starting from the position of the box and proceeds in the direction defined by the specified angle similar to the CSS gradient angle where <code>0deg</code> is up, with positive angles increasing in the clockwise direction, with the size value being similar to the CSS radial gradient size values from <code>closest-side</code> to <code>farthest-corner</code>, and the keyterm <code>contain</code>.</dd>
 <dt><code>url()</code></dt>
 <dd>References the ID of an SVG shape -- <code>circle</code>, <code>ellipse</code>, <code>line</code>, <code>path</code>, <code>polygon</code>, <code>polyline</code>, or <code>rect</code> -- using the shape's geometry as the path.</dd>
 <dt><code>&lt;basic-shape&gt;</code></dt>
 <dd>Specifies a <a href="/en-US/docs/Web/CSS/CSS_Shapes/Basic_Shapes">CSS shape</a> including <code>circle()</code>, <code>ellipse()</code>, <code>inset()</code>, <code>polygon()</code>, or <code>path()</code>.</dd>
 <dd>
 <dl>
  <dt><code>path()</code></dt>
  <dd>A path string defined with SVG coordinate syntax.</dd>
 </dl>
 </dd>
 <dt><code>none</code></dt>
 <dd>Specifies no motion path at all.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>This property defines a path an animated element can follow. An offset path is either a specified path with one or multiple sub-paths or the geometry of a not-styled basic shape. The element’s exact position on the offset path is determined by the {{cssxref("offset-distance")}} property. Each shape or path must define an initial position for the computed value of <code>0</code> for {{cssxref("offset-distance")}} and an initial direction which specifies the rotation of the object to the initial position.</p>

<p>Early versions of the spec called this property <code>motion-path</code>. It was changed to <code>offset-path</code> because the property describes static positions, not motion.</p>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Animating_an_element_with_offset-path">Animating an element with offset-path</h3>

<p>The <code>offset-path</code> properties in the CSS code sample defines a motion path that is identical to the <code>&lt;path&gt;</code> element in the SVG. The path, as can be seen in the rendering of the SVG code, is a line drawing of a house with a chimney.</p>

<h4 id="SVG">SVG</h4>

<p>The top and bottom halves of the scissors would appear in the top left of the canvas were they not positioned along the starting point of the motion path defined by <code>offset-path</code>.</p>

<pre class="brush: html notranslate">&lt;svg xmlns="http://www.w3.org/2000/svg"
     width="700"
     height="450"
     viewBox="350 0 1400 900"&gt;
  &lt;title&gt;House and Scissors&lt;/title&gt;
  &lt;rect x="595"
        y="423"
        width="610"
        height="377"
        fill="blue" /&gt;
  &lt;polygon points="506,423 900,190 1294,423"
           fill="yellow" /&gt;
  &lt;polygon points="993,245 993,190 1086,190 1086,300"
           fill="red" /&gt;
  &lt;path id="house" d="M900,190 L993,245 V201 A11,11 0 0,1 1004,190 H1075 A11,11 0 0,1 1086,201 V300 L1294,423 H1216 A11,11 0 0,0 1205,434 V789 A11,11 0 0,1 1194,800 H606 A11,11 0 0,1 595,789 V434 A11,11 0 0,0 584,423 H506 L900,190"
        fill="none"
        stroke="black"
        stroke-width="13"
        stroke-linejoin="round"
        stroke-linecap="round" /&gt;
  &lt;path id="firstScissorHalf" class="scissorHalf"
        d="M30,0 H-10 A10,10 0 0,0 -20,10 A20,20 0 1,1 -40,-10 H20 A10,10 0 0,1 30,0 M-40,20 A10,10 1 0,0 -40,0 A10,10 1 0,0 -40,20 M0,0"
        transform="translate(0,0)"
        fill="green"
        stroke="black"
        stroke-width="5"
        stroke-linejoin="round"
        stroke-linecap="round"
        fill-rule="evenodd" /&gt;
  &lt;path id="secondScissorHalf" class="scissorHalf"
        d="M30,0 H-10 A10,10 0 0,1 -20,-10 A20,20 0 1,0 -40,10 H20 A10,10 0 0,0 30,0 M-40,-20 A10,10 1 0,0 -40,0 A10,10 1 0,0 -40,-20 M0,0"
        transform="translate(0,0)"
        fill="forestgreen"
        stroke="black"
        stroke-width="5"
        stroke-linejoin="round"
        stroke-linecap="round"
        fill-rule="evenodd" /&gt;
&lt;/svg&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">.scissorHalf {
  offset-path: path('M900,190  L993,245 V201  A11,11 0 0,1 1004,190  H1075  A11,11 0 0,1 1086,201  V300  L1294,423 H1216  A11,11 0 0,0 1205,434  V789  A11,11 0 0,1 1194,800  H606  A11,11 0 0,1 595,789  V434  A11,11 0 0,0 584,423  H506 L900,190');
  animation: followpath 4s linear infinite;
}

@keyframes followpath {
   to {
     motion-offset: 100%;
     offset-distance: 100%;
   }
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Animating_an_element_with_offset-path', '100%', '450')}}</p>

<h2 id="Specifications">Specifications</h2>

<p>&lt;body&gt;</p>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Motion Path Level 1', '#offset-path-property', 'offset-path')}}</td>
   <td>{{Spec2('Motion Path Level 1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.offset-path")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("offset")}}</li>
 <li>{{cssxref("offset-distance")}}</li>
 <li>{{cssxref("offset-rotation")}}</li>
 <li><a href="/en-US/docs/Web/SVG/Tutorial/Paths">SVG &lt;path&gt; </a></li>
</ul>

<p>Other demos:</p>

<ul>
 <li><a href="https://codepen.io/team/css-tricks/pen/WZdKMq">Examples of the various values</a></li>
 <li><a href="http://codepen.io/ericwilligers/pen/jrbJPp">Triangle</a></li>
 <li><a href="http://codepen.io/ericwilligers/pen/bwVkNa">Scissors</a></li>
 <li><a href="http://jsfiddle.net/ericwilligers/r1snqdan/">Eyes</a></li>
</ul>
